

#Set up balloon help
global config
option add *Balloonhelp*background white widgetDefault
option add *Balloonhelp*foreground black widgetDefault
option add *Balloonhelpinfo.wrapLength 3i  widgetDefault
option add *Balloonhelp.info.justify left widgetDefault
#set ColorSpecs(BalloonHelp,Background) \#FA4
#set ColorSpecs(BalloonHelp,Foreground) black
#set ColorSpecs(Default,Background) \#FFD8B1

toplevel .balloonhelp \
    -class Balloonhelp \
    -background black \
    -borderwidth 1 \
    -relief flat
#label .balloonhelp.arrow -anchor nw -bitmap @arrow.xbm
#pack .balloonhelp.arrow -side left -fill y
label .balloonhelp.info \
    -font BalloonHelpFont \
    -bg $config(gui,color_balloonHelp_bg) \
    -fg $config(gui,color_balloonHelp_fg)
pack .balloonhelp.info -side left -fill y
wm overrideredirect .balloonhelp 1
wm withdraw .balloonhelp
#set config(balloonhelp) 1
array set OverlapP {}

#proc balloonhelp_control {state} {
#     global config
#     if {$state} {
#          set config(balloonhelp) 1
#     } else {
#	balloonhelp_cancel
#	set config(balloonhelp) 0
#     }
#}

proc balloonhelp_for {win mesg} {
    global bhInfo
    set bhInfo($win) $mesg
    set ::bhOverlapP($win) 1; 
    bind $win <Enter> {+balloonhelp_pending %W}
    bind $win <Leave> {+balloonhelp_cancel}
}

proc balloonhelpd_for {win mesg} {
    global bhInfo
    set ::bhOverlapP($win,d) 0;
    set bhInfo($win,d) $mesg
    bind $win <Enter> {+balloonhelp_show %W 1}
    bind $win <Leave> {+wm withdraw .balloonhelp}
}

proc balloonhelp_pending {win} {
     global bhInfo
     balloonhelp_cancel
    if {[info exist bhInfo($win,d)]} {
	set PendTime 2000;
    } else {
	set PendTime 1000;
    }
    set bhInfo(pending) [after $PendTime [list balloonhelp_show $win 0]]
}

proc balloonhelp_cancel {} {
    global bhInfo
    if { [info exists bhInfo(pending)]} {
	after cancel $bhInfo(pending)
	unset bhInfo(pending)
    }
    wm withdraw .balloonhelp
}

proc balloonhelp_show {win d} {
    global config bhInfo
    global bhOverlapP;
    if {$d} {
	set Overlap -10;
	set Text $bhInfo($win,d);
    } else { 
	set Overlap 25;
	set Text $bhInfo($win);
    }

    if {[winfo exists $win]} {
	if {$config(balloonhelp)} {
	    .balloonhelp.info configure -text $Text;
	    #Set abcissa
	    set MaxStringWidth 0;
	    if {$d} {
		set Text $bhInfo($win,d)
	    } else {
		set Text $bhInfo($win)
	    }
	    foreach line [split $Text "\n"] {
		set StringWidth \
                      [font measure BalloonHelpFont \
                          -displayof .balloonhelp.info $line]
		if {$StringWidth > $MaxStringWidth} {
		    set MaxStringWidth $StringWidth;
		}
	    }
	    set ScreenWidth [winfo screenwidth $win]
	    set Width [winfo width $win];
	    set LeftEdge  [winfo rootx $win];
	    set RightEdge [expr $LeftEdge + $Width];
	    if {$ScreenWidth - $RightEdge < $MaxStringWidth} { 
		if {$LeftEdge > $MaxStringWidth} {
		    set x [expr $LeftEdge - $MaxStringWidth + $Overlap];
		} else {
		    if {$ScreenWidth - $MaxStringWidth > 0} {
			set x [expr $RightEdge - $MaxStringWidth];
		    } else {
			set x [expr $ScreenWidth - $MaxStringWidth];
		    }
		}
	    } else {
		set x [expr $RightEdge - $Overlap];
	    }
	    #Set ordinate
	    set Height [winfo height $win];
	    set TopEdge [winfo rooty $win];
#	    set y [expr $TopEdge + ($Height/2)];
	    set y [expr $TopEdge + int(($Height/1.25))];
	    wm geometry .balloonhelp +$x+$y
	    wm deiconify .balloonhelp
	    raise .balloonhelp
	}
    }
    if {[info exist bhInfo(pending)]} {
	unset bhInfo(pending)
    }
}

#if 0
#proc ControlBalloonHelp {} {
#    if {$::BalloonHelpToggle} {
#	balloonhelp_control 1
#    } else {
#	balloonhelp_control 0
#    }
#}

#set BalloonHelpToggle 1
#ControlBalloonHelp;
#endif